package io.gitlab.jfronny.muscript.ast;

import io.gitlab.jfronny.muscript.ast.dynamic.DynamicCoerce;
import io.gitlab.jfronny.muscript.compiler.Type;

public abstract non-sealed class BoolExpr extends Expr<Boolean> {
    protected BoolExpr(int chStart, int chEnd) {
        super(chStart, chEnd);
    }

    @Override
    public Type getResultType() {
        return Type.Boolean;
    }

    @Override
    public abstract BoolExpr optimize();

    @Override
    public DynamicExpr asDynamicExpr() {
        return new DynamicCoerce(chStart, chEnd, this);
    }
}
