package io.gitlab.jfronny.muscript.ast;

import io.gitlab.jfronny.muscript.ast.dynamic.DynamicCoerce;
import io.gitlab.jfronny.muscript.compiler.Type;

public abstract non-sealed class NumberExpr extends Expr<Double> {
    protected NumberExpr(int chStart, int chEnd) {
        super(chStart, chEnd);
    }

    @Override
    public Type getResultType() {
        return Type.Number;
    }

    @Override
    public abstract NumberExpr optimize();

    @Override
    public DynamicExpr asDynamicExpr() {
        return new DynamicCoerce(chStart, chEnd, this);
    }
}
