package io.gitlab.jfronny.muscript.ast.bool;

import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.ast.BoolExpr;
import io.gitlab.jfronny.muscript.ast.Expr;
import io.gitlab.jfronny.muscript.ast.literal.BoolLiteral;

public class Not extends BoolExpr {
    private final BoolExpr inner;

    public Not(int chStart, int chEnd, BoolExpr inner) {
        super(chStart, chEnd);
        this.inner = inner;
    }

    @Override
    public Boolean get(Scope dataRoot) {
        return !inner.get(dataRoot);
    }

    @Override
    public BoolExpr optimize() {
        BoolExpr inner = this.inner.optimize();
        if (inner instanceof Not not) return not.inner;
        if (inner instanceof BoolLiteral literal) return Expr.literal(chStart, chEnd, !literal.value);
        return new Not(chStart, chEnd, inner);
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof Not not && inner.equals(not.inner);
    }
}
