package io.gitlab.jfronny.muscript.ast.literal;

import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.ast.BoolExpr;

public final class BoolLiteral extends BoolExpr {
    public final boolean value;

    public BoolLiteral(int chStart, int chEnd, boolean value) {
        super(chStart, chEnd);
        this.value = value;
    }

    @Override
    public Boolean get(Scope dataRoot) {
        return value;
    }

    @Override
    public BoolExpr optimize() {
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof BoolLiteral literal && value == literal.value;
    }
}
