package io.gitlab.jfronny.muscript.ast.literal;

import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.ast.DynamicExpr;

public final class DynamicLiteral<T> extends DynamicExpr {
    public final Dynamic<T> value;

    public DynamicLiteral(int chStart, int chEnd, Dynamic<T> value) {
        super(chStart, chEnd);
        this.value = value;
    }

    @Override
    public Dynamic<T> get(Scope dataRoot) {
        return value;
    }

    @Override
    public DynamicExpr optimize() {
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof DynamicLiteral<?> literal && value.equals(literal.value);
    }
}
