package io.gitlab.jfronny.muscript.ast.literal;

import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.ast.NumberExpr;

public final class NumberLiteral extends NumberExpr {
    public final double value;

    public NumberLiteral(int chStart, int chEnd, double value) {
        super(chStart, chEnd);
        this.value = value;
    }

    @Override
    public Double get(Scope dataRoot) {
        return value;
    }

    @Override
    public NumberExpr optimize() {
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof NumberLiteral literal && value == literal.value;
    }
}
