package io.gitlab.jfronny.muscript.ast.literal;

import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.ast.StringExpr;

public final class StringLiteral extends StringExpr {
    public final String value;

    public StringLiteral(int chStart, int chEnd, String value) {
        super(chStart, chEnd);
        this.value = value;
    }

    @Override
    public String get(Scope dataRoot) {
        return value;
    }

    @Override
    public StringExpr optimize() {
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof StringLiteral literal && value.equals(literal.value);
    }
}
