package io.gitlab.jfronny.commons;

import java.io.*;
import java.util.Locale;

public class StringFormatter {
    public static String toString(Object o) {
        if (o == null) return "null";
        else if (o instanceof Double d) {
            if (d % 1.0 == 0) return String.format(Locale.US, "%.0f", d);
            else if (d > 1) return String.format(Locale.US, "%.4f", d);
            else return String.format(Locale.US, "%s", d);
        } else if (o instanceof Throwable t) {
            try {
                return t.getMessage() + getStackTrace(t);
            } catch (IOException e) {
                return t.toString();
            }
        } else return o.toString();
    }

    public static String getStackTrace(Throwable t) throws IOException {
        try (ByteArrayOutputStream baot = new ByteArrayOutputStream()) {
            try (PrintStream ps = new PrintStream(baot, true)) {
                t.printStackTrace(ps);
            }
            return baot.toString();
        }
    }
}
