package io.gitlab.jfronny.commons.log;

import java.util.logging.Level;

public class JavaUtilLogger implements Logger {
    private final java.util.logging.Logger logger;

    public JavaUtilLogger(String name) {
        this.logger = java.util.logging.Logger.getLogger(name);
    }

    @Override
    public String getName() {
        return logger.getName();
    }

    @Override
    public void trace(String msg) {
        logger.log(Level.FINER, msg);
    }

    @Override
    public void trace(String format, Object arg) {
        logger.log(Level.FINER, format, arg);
    }

    @Override
    public void trace(String format, Object... args) {
        logger.log(Level.FINER, format, args);
    }

    @Override
    public void trace(String msg, Throwable t) {
        logger.log(Level.FINER, msg, t);
    }

    @Override
    public void debug(String msg) {
        logger.log(Level.FINE, msg);
    }

    @Override
    public void debug(String format, Object arg) {
        logger.log(Level.FINE, format, arg);
    }

    @Override
    public void debug(String format, Object... args) {
        logger.log(Level.FINE, format, args);
    }

    @Override
    public void debug(String msg, Throwable t) {
        logger.log(Level.FINE, msg, t);
    }

    @Override
    public void info(String msg) {
        logger.log(Level.INFO, msg);
    }

    @Override
    public void info(String format, Object arg) {
        logger.log(Level.INFO, format, arg);
    }

    @Override
    public void info(String format, Object... args) {
        logger.log(Level.INFO, format, args);
    }

    @Override
    public void info(String msg, Throwable t) {
        logger.log(Level.INFO, msg, t);
    }

    @Override
    public void warn(String msg) {
        logger.log(Level.WARNING, msg);
    }

    @Override
    public void warn(String format, Object arg) {
        logger.log(Level.WARNING, format, arg);
    }

    @Override
    public void warn(String format, Object... args) {
        logger.log(Level.WARNING, format, args);
    }

    @Override
    public void warn(String msg, Throwable t) {
        logger.log(Level.WARNING, msg, t);
    }

    @Override
    public void error(String msg) {
        logger.log(Level.SEVERE, msg);
    }

    @Override
    public void error(String format, Object arg) {
        logger.log(Level.SEVERE, format, arg);
    }

    @Override
    public void error(String format, Object... args) {
        logger.log(Level.SEVERE, format, args);
    }

    @Override
    public void error(String msg, Throwable t) {
        logger.log(Level.SEVERE, msg, t);
    }
}
