package io.gitlab.jfronny.commons.test;

import io.gitlab.jfronny.commons.log.*;
import org.junit.jupiter.api.*;

import static org.junit.jupiter.api.Assertions.*;

public class LoggerTest {
    @BeforeEach
    void prepare() {
        Logger.resetFactory();
    }

    @Test
    void testFactory() {
        assertEquals(StdoutLogger.class, assertInstanceOf(HotSwappingDelegateLogger.class, Logger.forName("Joe")).getDelegate().getClass());
    }

    @Test
    void testRegisterFactory() {
        HotSwappingDelegateLogger logger = assertInstanceOf(HotSwappingDelegateLogger.class, Logger.forName("Joe"));
        assertEquals(StdoutLogger.class, logger.getDelegate().getClass());
        Logger.registerFactory(s -> new NopLogger());
        assertEquals(NopLogger.class, logger.getDelegate().getClass());
    }
}
